import java.io.*;
import java.util.*;

public class Task_C {

    static Random rand = new Random();
    static Node root = null;
    public void solve() throws IOException {
        //PriorityQueue<Man> q = new PriorityQueue<Man>();
        int n = nextInt();
        int m = nextInt();
        Man[] a = new Man[n];
        for (int i  = 0; i < n; i++) {
            int t = nextInt();
            int lev = nextInt();
            a[i] = new Man(i, lev - 1, t);
        }
//        Node root = new Node(null);
//        Node now = new Node(a[0]);
//        root.r = now;
//        now.l = root;
//        for (int i = 1; i < n; i++) {
//            Node tmp = new Node(a[i]);
//            now.r = tmp;
//            tmp.l = now;
//            now = tmp;
//        }
        int last = 0;
        int id = 0;
        long time = 0;
        //now = root.r;
        long[] ans = new long[n];
        ArrayList<Buf> el = new ArrayList<>();
        while (id < n) {
//            time = Math.max(time, now.value.t);
//            last = now.value.level;
//            ans[now.value.id] = time + 2 * last;
//            Node go = now.r;
//            while (go != null) {
//                if ((go.value.t <= time + 2 * last - go.value.level)) {
//                    if (go.value.level <= last) {
//                        ans[go.value.id] = time + 2 * last;
//                        Node buf = go.l;
//                        go.l.r = go.r;
//                        if (go.r != null) {
//                            go.r.l = buf;
//                        }
//                    }
//                } else {
//                    break;
//                }
//                go = go.r;
//            }
//            now = now.r;
//            time += 2 * last;
            if (el.size() != 0) {
                int l = -1;
                int r = el.size() - 1;
                long val = a[id].level + a[id].t;
                while ((r - l) > 1) {
                    int mid = (r + l) / 2;
                    if (val > el.get(mid).time) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                if (el.get(r).time >= val) {
                    boolean flag = false;
                    for (int i = r; i < el.size(); i++) {
                        long x = el.get(i).m.level;
                        if (x >= a[id].level) {
                            ans[id] = el.get(i).time;
                            id++;
                            flag = true;
                            break;
                        }
                    }
                    if (flag) {
                        continue;
                    }
                }
            }
            time = Math.max(time, a[id].t) + 2 * a[id].level;
            ans[id] = time;
            el.add(new Buf(a[id], time));
            add(el.size(), a[id].level);
            id++;

        }
        for (int i = 0; i < n; i++) {
            out.println(ans[i]);
        }
    }
    static class Buf{
        Man m;
        long time;
        public Buf(Man m, long time) {
            this.m = m;
            this.time = time;
        }
    }
    static class Man {
        int id, level, t;
        public Man(int id, int level, int t) {
            this.id = id;
            this.level = level;
            this.t = t;
        }

//        @Override
//        public int compareTo(Man o) {
//            if (t - o.t > 0) {
//                return 1;
//            }
//            if (t - o.t < 0) {
//                return -1;
//            }
//            if (id - o.id > 0){
//                return 1;
//            }
//            if (id - o.id < 0){
//                return -1;
//            }
//            return 0;
//        }
    }
    static class Node {
        Node l, r;
        int y, size;
        long max;
        long val;
        public Node(long val) {
            this.y = rand.nextInt(Integer.MAX_VALUE);
            this.size = 1;
            this.val = val;
            this.l = null;
            this.r = null;
            this.max = val;
        }
    }
    static class Pair {
        Node f, s;
        public Pair(Node f, Node s) {
            this.f = f;
            this.s = s;
        }
    }
    static Node merge(Node t1, Node t2) {
        if (t1 == null) return t2;
        if (t2 == null) return t1;
        if (t1.y >= t2.y) {
            t1.r = merge(t1.r, t2);
            update(t1);
            return t1;
        } else {
            t2.l = merge(t1, t2.l);
            update(t2);
            return t2;
        }
    }
    static Pair split(Node t, int x) {
        if (t == null) return new Pair(null, null);
        int k = get_size(t.l);
        if (k >= x) {
            Pair p = split(t.l, x);
            t.l = p.s;
            update(t);
            return new Pair(p.f, t);
        } else {
            Pair p = split(t.r, x - k - 1);
            t.r = p.f;
            update(t);
            return new Pair(t, p.s);
        }
    }
    static int get_size(Node t) {
        if (t == null) return 0;
        return t.size;

    }
    static long get_max(Node t) {
        if (t == null) return Integer.MIN_VALUE;
        return t.max;
    }
    static void update(Node t){
        if (t == null) return;
        t.size = get_size(t.l) + get_size(t.l) + 1;
        t.max = Math.max(get_max(t.l), Math.max(get_max(t.r), t.max));
    }
    static void add(int id, long x) {
        Pair p = split(root, id);
        root = merge(p.f, merge(p.s, new Node(x)));
        update(root);
    }
    static long max(int l) {
        Pair p = split(root, l);
        long max = p.s.max;
        root = merge(p.f, p.s);
        update(root);
        return max;
    }
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Task_C().run();
    }

}