import java.io.*;
import java.util.*;

public class Task_C {

    static ArrayList<Integer>[] es;
    static long[] dp;
//    static int[] size;
//    static int[][] es;
//    static int[] a;
    static int max_depth2 = 1;
    static int max_depth = 0;
    static long nice = 0;
    static int m, n;
    static boolean flag;
    public void solve() throws IOException {
        n = nextInt();
        m = nextInt();
        es = new ArrayList[n];
        dp = new long[n];
        for (int i = 0; i < n; i++) {
            es[i] = new ArrayList<>();
        }
        for (int i = 1; i < n; i++) {
            int x = nextInt() - 1;
            es[x].add(i);
        }
        //dfs_depth(0, 1);
        dfs_dp(0, 1);
        if (flag) {
            out.print(nice + 2 * (m-1) * (max_depth - 1));
        } else {
            out.print(nice +  (m-1) * (max_depth - 1));
        }
    }

//    static void dfs_depth(int v, int depth) {
//        max_depth = Math.max(max_depth, depth);
//        for (int u : es[v]) {
//            dfs_depth(u, depth + 1);
//        }
//    }
    static void dfs_dp(int v, int depth) {
        max_depth = Math.max(depth, max_depth);
        long max1 = 0;
        long max2 = 0;
        for (int u : es[v]) {
            dfs_dp(u, depth + 1);
            if (dp[u] > max1) {
                if (max1 > max2) {
                    max2 = max1;
                }
                max1 = dp[u];
            } else {
                if (dp[u] > max2) {
                    max2 = dp[u];
                }
            }
        }

        if (es[v].size() == 0) {
            dp[v] = (m - 1) * max_depth2 + 1;
        } else {
            if (nice < max1 + max2 + 1) {
                if (max1 != 0 && max2 != 0) {
                    flag = true;
                } else {
                    flag = false;
                }
                nice = max1 + max2 + 1;
            }
            dp[v] = max1 + 1;
        }
    }
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Task_C().run();
    }

}