import java.io.*;
import java.util.*;

public class Task_C {


    public void solve() throws IOException {
        //PriorityQueue<Man> q = new PriorityQueue<Man>();
        int n = nextInt();
        int m = nextInt();
        Man[] a = new Man[n];
        for (int i  = 0; i < n; i++) {
            int t = nextInt();
            int lev = nextInt();
            a[i] = new Man(i, lev - 1, t);
        }
        Node root = new Node(null);
        Node now = new Node(a[0]);
        root.r = now;
        now.l = root;
        for (int i = 1; i < n; i++) {
            Node tmp = new Node(a[i]);
            now.r = tmp;
            tmp.l = now;
            now = tmp;
        }
        int last = 0;
        long time = 0;
        now = root.r;
        long[] ans = new long[n];
        while (now != null) {
            time = Math.max(time, now.value.t);
            last = now.value.level;
            ans[now.value.id] = time + 2 * last;
            Node go = now.r;
            while (go != null) {
                if ((go.value.t <= time + last + last - go.value.level)) {
                    if (go.value.level <= last) {
                        ans[go.value.id] = time + 2 * last;
                        Node buf = go.l;
                        go.l.r = go.r;
                        if (go.r != null) {
                            go.r.l = buf;
                        }
                    }
                } else {
                    break;
                }
                go = go.r;
            }
            now = now.r;
            time += 2 * last;
        }
        for (int i = 0; i < n; i++) {
            out.println(ans[i]);
        }
    }

    static class Man {
        int id, level, t;
        public Man(int id, int level, int t) {
            this.id = id;
            this.level = level;
            this.t = t;
        }

//        @Override
//        public int compareTo(Man o) {
//            if (t - o.t > 0) {
//                return 1;
//            }
//            if (t - o.t < 0) {
//                return -1;
//            }
//            if (id - o.id > 0){
//                return 1;
//            }
//            if (id - o.id < 0){
//                return -1;
//            }
//            return 0;
//        }
    }
    static class Node {
        Node l, r;
        Man value;
        public Node(Man value) {
            this.value = value;
            this.l = null;
            this.r = null;
        }
    }
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Task_C().run();
    }

}